VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsRecycleBin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' ------------------------------------------------------------------
'                   Klassenmodul clsRecycleBin
' ------------------------------------------------------------------
'
' Zweck:  Anzeige des Papierkorb-Inhalts, Verschieben von Dateien in
'         den Papierkorb sowie Lschen(*) und Zhlen(*) seines
'         Inhalts
'         (* = nur bei installiertem Internet Explorer ActiveDesktop)
'
' Stand:  11/98, Tips&Tricks der BasicPro 6/98
'
' ------------------------------------------------------------------
'                        ffentliche Elemente:
' ------------------------------------------------------------------
'
' Methoden:
'
'  - AddFiles
'    Blendet ein Windows95-spezifisches Men ein. Werte fr Dialog:
'
'  - WindowsFunction(ByVal WinFunction As FUNCTIONS)
'    Nutzt eine Windows95-spezifische Funktion. Werte fr WinFunction:
'                             rechtem Klick auf aktives Fenster
'
' ------------------------------------------------------------------
'           Copyright  1998 Mathias Schiffer fr BasicPro
'             BasicPro Online: http:'www.basicworld.com
' ------------------------------------------------------------------

' -----
' TYPEN
' -----
Private Type LARGE_INTEGER
  Teil1 As Long
  Teil2 As Long
End Type

Private Type SHQUERYRBININFO
  cbSize    As Long
  Size      As LARGE_INTEGER
  ItemCount As LARGE_INTEGER
End Type

Private Type SHFILEOPSTRUCT
  hwnd      As Long
  wFunc     As Long
  pFrom     As String
  pTo       As String
  fFlags    As Integer
  fAborted  As Boolean
  hNameMaps As Long
  sProgress As String
End Type


' ---------
' KONSTANTE
' ---------

Private Const FO_MOVE = &H1     ' Dateien verschieben
Private Const FO_COPY = &H2     ' Dateien kopieren
Private Const FO_DELETE = &H3   ' Dateien in den Papierkorb verschieben
Private Const FO_RENAME = &H4   ' Dateien umbenennen

Private Const FOF_MULTIDESTFILES = &H1      ' Mehrere Zieldateien (fr kopieren, verschieben, umbenennen)
Private Const FOF_CONFIRMMOUSE = &H2        ' Besttigung
Private Const FOF_SILENT = &H4              ' Keine Darstellung des Lschvorgangs
Private Const FOF_RENAMEONCOLLISION = &H8   ' Falls Zielname vergeben, automatscih umbenennen
Private Const FOF_NOCONFIRMATION = &H10     ' Keine Besttigungen anfordern
                                     
Private Const FOF_ALLOWUNDO = &H40          ' UNDO erlauben
Private Const FOF_FILESONLY = &H80          ' WildCards nur auf Dateien beziehen
Private Const FOF_SIMPLEPROGRESS = &H100    ' Einfache Fortschrittsanzeige
Private Const FOF_NOCONFIRMMKDIR = &H200    ' Anlegen von Verzeichnissen ohne Anfrage
Private Const FOF_NOERRORUI = &H400         ' Kein UserInterface bei Fehlern
Private Const FOF_NOCOPYSECURITYATTRIBS = &H800 ' Sicherheitsattribute nicht mit kopieren

Private Const SHERB_NOCONFIRMATION = &H1    ' Papierkorb ohne Sicherheitsabfrage lschen
Private Const SHERB_NOPROGRESSUI = &H2      ' Papierkorb leeren ohne GUI
Private Const SHERB_NOSOUND = &H4           ' Keinen Sound beim Lschen des Papierkorbs

Private Const SW_SHOWNORMAL = 1
Private Const HWND_DESKTOP = 0

' --------------
' API-FUNKTIONEN
' --------------

Private Declare Function SHFileOperation Lib "shell32.dll" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function SHQueryRecycleBin Lib "shell32" Alias "SHQueryRecycleBinA" (ByVal pszRootPath As String, pSHQUERYRBININFO As SHQUERYRBININFO) As Long
Private Declare Function SHEmptyRecycleBin Lib "shell32" Alias "SHEmptyRecycleBinA" (ByVal hwnd As Long, ByVal pszRootPath As String, ByVal dwFlags As Long) As Long


Public Sub AddFiles(ParamArray Filename() As Variant)
Dim i As Integer, Files As String, SHOP As SHFILEOPSTRUCT
' Dateien in den Papierkorb verschieben

  ' ParamArray in einen vbNullChar-separierten String wandeln
  For i = LBound(Filename) To UBound(Filename)
   Files = Files & Filename(i) & vbNullChar
  Next i
  Files = Files & vbNullChar  ' abschlieendes vbNullChar

  With SHOP                   ' Parameter festlegen
    .wFunc = FO_DELETE        ' in den Papierkorb lschen
    .pFrom = Files            ' Quelldateien
    .fFlags = FOF_ALLOWUNDO   ' Rckgngig machen erlauben
  End With

 SHFileOperation SHOP

End Sub


Public Property Get ItemCount(Optional ByVal strBin As String) As Long
Dim SHQBI As SHQUERYRBININFO
 
  With SHQBI
    .cbSize = LenB(SHQBI)
  End With
  
  On Error Resume Next
  ' Ermitteln der Elemente im Papierkorb
  SHQueryRecycleBin strBin, SHQBI
  If Err.Number <> 0 Then ItemCount = -1: Exit Property
  
  ItemCount = SHQBI.ItemCount.Teil1 + SHQBI.ItemCount.Teil2

End Property


Public Function Clear(Optional ByVal strBin As String, Optional hwndParent As Long = HWND_DESKTOP, Optional ByVal Confirm As Boolean = True, Optional ByVal GUI As Boolean = True, Optional Sound As Boolean = True) As Boolean
Dim lngOptions As Long
      
  ' Optionen abfragen
  If Confirm Then lngOptions = SHERB_NOCONFIRMATION
  If Not GUI Then lngOptions = lngOptions Or SHERB_NOPROGRESSUI
  If Not Sound Then lngOptions = lngOptions Or SHERB_NOSOUND
  
  On Error Resume Next
  ' Papierkorb leeren
  SHEmptyRecycleBin hwndParent, strBin, lngOptions
    
  Clear = (Err.Number = 0)
  
End Function

Public Sub ShowBin(Optional hwndParent As Long = HWND_DESKTOP)
Dim strParameter As String
  ' Inhalt des Papierkorbs anzeigen
  strParameter = "/root,::{645FF040-5081-101B-9F08-00AA002F954E}"
  ShellExecute hwndParent, "Open", "explorer.exe", strParameter, 0&, SW_SHOWNORMAL

End Sub



